From 1d0b49a5ec3ddc40e345ef5bf2387cc6cf3683ac Mon Sep 17 00:00:00 2001
From: Thomas Munro <thomas.munro@gmail.com>
Date: Mon, 22 Apr 2024 09:07:58 +1200
Subject: [PATCH 2/2] fixup

---
 src/test/perl/PostgreSQL/Test/Cluster.pm | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

diff --git a/src/test/perl/PostgreSQL/Test/Cluster.pm b/src/test/perl/PostgreSQL/Test/Cluster.pm
index 52972a9746..f87725f686 100644
--- a/src/test/perl/PostgreSQL/Test/Cluster.pm
+++ b/src/test/perl/PostgreSQL/Test/Cluster.pm
@@ -908,7 +908,8 @@ sub init_from_backup
 		PostgreSQL::Test::RecursiveCopy::copypath($backup_path, $data_path,
 			'filterfn' => sub {
 				my ($path) = @_;
-				if ($path =~ /^pg_tblspc\/(\d+)$/ && -l "$backup_path/$path")
+				if ($path =~ /^pg_tblspc\/(\d+)$/ &&
+					PostgreSQL::Test::Utils::is_symlink("$backup_path/$path"))
 				{
 					push @tsoids, $1;
 					return 0;
@@ -923,7 +924,7 @@ sub init_from_backup
 		# Now use the list of tablespace links to copy each tablespace.
 		for my $tsoid (@tsoids)
 		{
-			my $olddir = readlink("$backup_path/pg_tblspc/$tsoid")
+			my $olddir = PostgreSQL::Test::Utils::read_symlink("$backup_path/pg_tblspc/$tsoid")
 				|| die "readlink $backup_path/pg_tblspc/$tsoid: $!";
 
 			die "no tablespace mapping for $olddir"
-- 
2.39.3 (Apple Git-146)

